=== debian/control ===
Source: ros-indigo-constrained-ik
Section: misc
Priority: extra
Maintainer: Jeremy Zoss, SwRI <jzoss@swri.org>
Build-Depends: debhelper (>= 9.0.0), libboost-all-dev, libgtest-dev, ros-indigo-catkin, ros-indigo-cmake-modules, ros-indigo-dynamic-reconfigure, ros-indigo-eigen-conversions, ros-indigo-industrial-collision-detection, ros-indigo-kdl-parser, ros-indigo-moveit-core, ros-indigo-moveit-ros-planning, ros-indigo-orocos-kdl, ros-indigo-pluginlib, ros-indigo-roscpp, ros-indigo-tf-conversions, ros-indigo-urdf
Homepage: http://ros.org/wiki/constrained_ik
Standards-Version: 3.9.2

Package: ros-indigo-constrained-ik
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev, ros-indigo-cmake-modules, ros-indigo-dynamic-reconfigure, ros-indigo-eigen-conversions, ros-indigo-industrial-collision-detection, ros-indigo-kdl-parser, ros-indigo-moveit-core, ros-indigo-moveit-ros-planning, ros-indigo-orocos-kdl, ros-indigo-pluginlib, ros-indigo-roscpp, ros-indigo-tf-conversions, ros-indigo-urdf
Description: Constraint-based IK solver.
 Good for high-DOF robots or underconstrained tasks.
